package com.galaxis.manatee.capsule.dto;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/28 5:44 下午
 */
@Data
public class ChuanyunReimbursementDTO {

    /**
     * 主键
     */
    private String objectId;

    /**
     * 公司编码
     *
     */
    private String reimburseUserCompanyCode;

    /**
     * 对公/对私
     */
    private String privateOrPublic;

    /**
     * 流水号
     */
    private String serialNumber;

    /**
     * 业务日期
     */
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime businessDate;

    /**
     * 币种
     */
    private String currency;

    /**
     * 汇率
     */
    private BigDecimal exchangeRate;

    /**
     * 供应商编码
     */
    private String supplierCode;

    /**
     * 集团项目编码
     */
    private String groupProjectCode;

    /**
     * 报销人工号
     */
    private String reimburseUserCode;

    /**
     * 报销人成本中心编码
     */
    private String reimburseUserCostCode;

    /**
     * 核销方式
     */
    private String writeOffMethod;

    /**
     * 报销总金额
     */
    private BigDecimal amount;

    /**
     * 受益公司银行代码
     */
    private String beneficiaryBankCode;

    /**
     * 受益公司银行账号
     */
    private String beneficiaryBankAccount;

    /**
     * 结算方式
     */
    private String settlementMethod;

    /**
     * 报销原因
     */
    private String reason;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 创建时间
     */
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime createdTime;

    /**
     * u9传入标识
     */
    private Integer erpFlag;

    /**
     * 受益成本中心编码
     */
    private String beneficiaryCostCode;

    /**
     * 报销明细
     */
    private List<ChuanyunReimbursementDetailDTO> detailList;
}
